//+---------------------------------------------------------------------+
//| BT-PF_Func_v0.1b.mqh  "Back test in the Indicator" function         |
//|   Copyright  2011, RRJ                                             |
//|     http://kamome.2ch.net/test/read.cgi/livemarket2/1304547533/     |
//+---------------------------------------------------------------------+

#define FONT    "Arial"

//-- Display function --------------------------------------------------
void PutDispX( int i, int iX, string sDisp )
{
    string  sName   = SHORT_NAME + "_BTI2" + i;

    ObjectCreate( sName, OBJ_LABEL,0,0,0);
    ObjectSetText(sName, sDisp, 8, FONT, White);
    ObjectSet   ( sName, OBJPROP_CORNER,     0);
    ObjectSet   ( sName, OBJPROP_XDISTANCE, iX);
    ObjectSet   ( sName, OBJPROP_YDISTANCE, 12 * i);
}


void PutDispX2( int i, string sDisp )
{
    string  sName   = SHORT_NAME + "_BTI2" + i;

    ObjectSetText(sName, sDisp, 8, FONT, White);
}


void PutStr8( int i, int cmd, int iColor, string sTName )
{
    string  sName   = SHORT_NAME + TimeToStr(Time[i],TIME_DATE|TIME_SECONDS);

    ObjectCreate( sName, OBJ_TEXT, 0, 0, 0);
    if      (cmd==OP_BUY )  ObjectMove( sName, 0, Time[i], Low[i]  - 15 * Point );
    else if (cmd==OP_SELL)  ObjectMove( sName, 0, Time[i], High[i] + 30 * Point );
    ObjectSetText(sName, sTName, 8, FONT, iColor    );
}


void SlopeLineR(int m, int i, int j, double dPrice2, double dPrice1, color cColor )
{
    string  Name    = SHORT_NAME + "_BTL"+m+TimeToStr(Time[i],TIME_DATE|TIME_SECONDS);

    ObjectCreate( Name, OBJ_TREND, 0, Time[i], dPrice2, Time[j], dPrice1 );
    ObjectSet   ( Name, OBJPROP_COLOR,  cColor  );
    ObjectSet   ( Name, OBJPROP_STYLE,  STYLE_SOLID );
    ObjectSet   ( Name, OBJPROP_BACK,   false   );
    ObjectSet   ( Name, OBJPROP_RAY,    false   );
    ObjectSet   ( Name, OBJPROP_WIDTH,  1   );
}


void BT_DelAllObject()
{
    //-- \bh炷ׂẴIuWFNg擾č폜
    for (int i=ObjectsTotal(); i>=0; i--) {
        string ObjName  = ObjectName(i);
        if (StringSubstr(ObjName,0,3) == SHORT_NAME) {
            ObjectDelete(ObjName);
        }
    }
}


//-- Back test function ------------------------------------------------
#define     _Nbt    200
datetime    BT.daEntryTime[_Nbt];       //
int         BT.iBuySell[_Nbt];          //  BUY=1, SELL=-1, NoPos=0
double      BT.daOpen[_Nbt];            //
double      BT.daTP[_Nbt];              //
double      BT.daSL[_Nbt];              //
double      BT.daTP_Bin[_Nbt];          //
double      BT.daSL_Bin[_Nbt];          //
int         BT.iMethod[_Nbt];           //
extern  double  dSpread = 3.0;

double      daBTProfit[BT_SIG_QTY];
double      daBTLoss[BT_SIG_QTY];
int         iaBTPrfTrades[BT_SIG_QTY];
int         iaBTLssTrades[BT_SIG_QTY];


void BT_Init_Law(int i)
{
    BT.daEntryTime[i]=0;
    BT.iBuySell[i]  = 0;
    BT.daOpen[i]    = 0.0;          //
    BT.daTP[i]      = 0.0;
    BT.daSL[i]      = 0.0;
    BT.daTP_Bin[i]  = 0.0;          //
    BT.daSL_Bin[i]  = 0.0;          //
    BT.iMethod[i]   = -1;
}


void BT_Init()
{
    for (int i=0; i<_Nbt; i++) {
        BT_Init_Law(i);
        daBTProfit[i]       = 0.0;
        daBTLoss[i]         = 0.0;
        iaBTPrfTrades[i]    = 0;
        iaBTLssTrades[i]    = 0;
    }

    //-- Prepare Information ---------------
    PutDispX( 3, 130, "BT result (unstable)" );
    for (i=0; i<=BT_SIG_QTY; i++) {
        PutDispX( i+4, 140, "PF: (N/A)" );
    }
}


int BT_SigSend(
        int     cmd,        //  OP_BUY  0   Buying position.    
                            //  OP_SELL 1   Selling position.   蒍
        double  price,
        double  stoploss,
        double  takeprofit,
        int     iBar,
        int     iMethod     )
{
    string  sStr    = BT_CB_MethodName( iMethod );

    PutStr8( iBar, cmd, White, sStr );

    if (cmd==OP_BUY) {                  //  Buying  position.   
        CrossUp[iBar]   = Low[iBar]  - Point*0.5;
    } else if (cmd==OP_SELL) {          //  Selling position.   蒍
        CrossDown[iBar] = High[iBar] + Point*0.5;
    }

    for (int i=0; i<_Nbt; i++)
        if (BT.daEntryTime[i]==0)
            break;

    if (i!=_Nbt) {
        BT.daEntryTime[i]=Time[iBar];
        BT.daTP[i]      = MathAbs(price-takeprofit-SPREAD);
        BT.daSL[i]      = MathAbs(price-stoploss  +SPREAD);
        BT.daTP_Bin[i]  = takeprofit;
        BT.daSL_Bin[i]  = stoploss;
        BT.daOpen[i]    = price;
        if (cmd==OP_BUY) {              //  Buying  position.   
            BT.iBuySell[i]  =  1;
        } else if (cmd==OP_SELL) {      //  Selling position.   蒍
            BT.iBuySell[i]  = -1;
        }
        BT.iMethod[i]   = iMethod;
    }
    return (0);
}


void BT_Record( int iTckt, int iWon, int iBar2, int iBar1 )
{
    int iMthd   = BT.iMethod[iTckt];

    if (iWon==1) {
        daBTProfit[iMthd]   += BT.daTP[iTckt];
        SlopeLineR( iMthd, iBar2, iBar1+1, BT.daOpen[iTckt], BT.daTP_Bin[iTckt], Blue );
        iaBTPrfTrades[iMthd]++;
    } else if (iWon==-1) {
        daBTLoss[iMthd]     -= BT.daSL[iTckt];
        SlopeLineR( iMthd, iBar2, iBar1+1, BT.daOpen[iTckt], BT.daSL_Bin[iTckt], Red  );
        iaBTLssTrades[iMthd]++;
    }
    if (iWon!=0) {
        BT_Init_Law(iTckt);
    }
}


int BT_Trace( int iBar )
{
    bool bPosClose  = false;

    for (int i=0; i<_Nbt; i++)
        if (BT.daEntryTime[i]!=0) {
            int iBBar   = iBarShift(NULL, 0, BT.daEntryTime[i], false);
            int j       = BT.iMethod[i];
            int iWon    = 0;

            if (iBar > iBBar) iBar = iBBar-1;

            if (BT.iBuySell[i] ==  1)                       //  Buy :   (Ask to Bid)
                if (        BT.daSL_Bin[i] > Low[iBar+1]                ) { //  Stoploss
                    iWon    = -1;
                } else if ( BT.daTP_Bin[i] < High[iBar+1]               ) { //  Takeprofit
                    iWon    =  1;
                }
            if (BT.iBuySell[i] == -1)                       //  Sell:   (Bid to Ask)
                if (        BT.daSL_Bin[i] < High[iBar+1]+SPREAD*Point  ) { //  Stoploss
                    iWon    = -1;
                } else if ( BT.daTP_Bin[i] > Low[iBar+1] +SPREAD*Point  ) { //  Takeprofit
                    iWon    =  1;
                }

            if (iWon!=0) {
                BT_Record( i, iWon, iBBar, iBar );
                bPosClose   = true;
            }
            iWon    = 0;
        }

    if (bPosClose) {
        double  daBTSumProfit   = 0.0,
                daBTSumLoss     = 0.0;
        string  sStr;

        for (i=0; i<BT_SIG_QTY; i++) {
            daBTSumProfit   += daBTProfit[i];
            daBTSumLoss     -= daBTLoss[i];
            if (daBTLoss[i]==0.0)
                PutDispX2( i+4, "PF: (N/A)" );
            else {
                int n   = iaBTPrfTrades[i]+iaBTLssTrades[i];
                sStr    = "PF: " + DoubleToStr(-1.0*daBTProfit[i]/daBTLoss[i],3);
                if (n!=0)
                    sStr    = sStr + " (" + DoubleToStr(100.0*iaBTPrfTrades[i]/n, 1) + "%, " + iaBTPrfTrades[i] + ":" + iaBTLssTrades[i] + ")";
                PutDispX2( i+4, sStr );
            }
        }

        if (daBTSumLoss==0.0)
            PutDispX2( i+4, "PF: (N/A)" );
        else {
            sStr    = "PF: " + DoubleToStr(daBTSumProfit/(daBTSumLoss),3);
            PutDispX2( i+4, sStr );
        }
    }
    return (0);
}
